package fxLisaaReissu;

import java.io.IOException;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.ResourceBundle;

import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import fxKalenteri.KalenteriMain;
import fxKaljoja.KalojaGUIController;
import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Label;
import javafx.scene.control.ListView;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

import Luokat.*;
import fxKaljoja.*;
/**
 * @author miikk
 * @version 29.1.2025
 *
 */
public class LisaaReissuGUIController implements Initializable, ModalControllerInterface<String> {

	@FXML
	private Label tiedot;

	@FXML
    private TextField Pvm;

	 @FXML
	 private TextArea kaloja;

    @FXML
    private TextField keli;

    @FXML
    private TextField sijainti;
    
    private List<Saalis> saaliit = new ArrayList<>();

	
	
	@FXML private void handleTallenna() {
    	 Tallenna();

    }
	 
	 @FXML private void handlePoista(){
		 Poista();
	 }
	 
	 @FXML private void handleKaloja() {
		 	Kaloja();
	 }
	 
	 //-------------------------//
	 
	 private void Kaloja() {

		ModalController.showModal(KalenteriMain.class.getResource("/fxKaljoja/KalojaGUIView.fxml"),
				 "Lisää Kala",null,saaliit);
		 liitaKaloja();
	 }
	 
	 public void liitaKaloja() {
		 for(Saalis s : saaliit){
			 Platform.runLater(()->{kaloja.appendText(s.getLaji() + " " + s.getKoko());kaloja.appendText("\n");});
		 }
	 }
	 
	 private void Poista() {
		 Dialogs.showMessageDialog("poistutaan! Mutta ei toimi vielä");
	 }
	 
	 public void Tallenna() {

		 Reissu a = new Reissu(1 , Pvm.getText(), sijainti.getText(),keli.getText());
		 for(Saalis saalis : saaliit) {
			 saalis.setReissunTagi(a.getTag());
			 System.out.println(saalis.tiedotTallenusMuodossa());
		 }
		 System.out.println(a);
		 
	 }

	
	 
	@Override
	public String getResult() {
		return "";
	}

	@Override
	public void setDefault(String s) {

	}

	@Override
	public void handleShown() {

	}

	@Override
	public void initialize(URL url, ResourceBundle resourceBundle) {
		kaloja = new TextArea();
		kaloja.setEditable(true);
		kaloja.setWrapText(true);
		Platform.runLater(() -> kaloja.appendText("Hei kaikki"));
	}
}